cdac.medinfo.sdk.hl7282.baselibs.segments

## Class MFA

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.MFA

- All Implemented Interfaces:
    ISegment

      public class MFA
      extends Segment

  MFA - Master File Acknowledgment Segment.

  The Technical Steward for the MFE segment is CQ.

  Represents an HL7 MFA message segment. This segment has the following fields:

  MFA-1: Record-Level Event Code (ID)Required
  MFA-2: MFN Control ID (ST)Conditional
  MFA-3: Event Completion Date/Time (DTM)Optional
  MFA-4: MFN Record Level Error Return (CWE)Required
  MFA-5: Primary Key Value - MFA (Varies)Required
  MFA-6: Primary Key Value Type - MFA (ID)Required

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MFA()` Constructs the MFA segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addprimaryKeyValueMFA(IDataType objprimaryKeyValueMFA)` Add the Primary Key Value MFA.
    `void` | `addPrimaryKeyValueType(ID objtempPrimaryKeyValueTypeMFA)` Add the Primary Key Value Type MFA.
    `void` | `addPrimaryKeyValueType(java.lang.String strCharacterSet)` Add the Primary Key Value Type MFA.
    `DTM` | `getEventCompletionDate_Time()` Retrieves the Event Completion Date Time.
    `ST` | `getMFNControlID()` Retrieves the MFN Control ID.
    `CWE` | `getMFNRecordLevelErrorReturn()` Retrieves the MFN Record Level Error Return.
    `ISingleCollection<IDataType>` | `getPrimaryKeyValueMFA()` Retrieves the Primary Key Value MFA.
    `ISingleCollection<ID>` | `getPrimaryKeyValueTypeMFA()` Retrieves the Primary Key Value Type MFA.
    `ID` | `getRecordLevelEventCode()` Retrieves the Record Level Event Code.
    `int` | `parse(java.lang.String strSegmentStream, IDelimiter objIDelimiter)` Parses HL7 Segment Strings from any Stream into HL7 Segment object.
    `void` | `setEventCompletionDate_Time(DTM objeventCompletionDate_Time)` SetEventCompletionDate_Time
    `void` | `setEventCompletionDate_Time(java.lang.String strTime)` SetEventCompletionDate_Time
    `void` | `setMFNControlID(ST objmFNControlID)` Set the MFN Control ID.
    `void` | `setMFNControlID(java.lang.String strMFNControlID)` Set the MFN Control ID.
    `void` | `setMFNRecordLevelErrorReturn(CWE objmFNRecordLevelErrorReturn)` Set the MFN Record Level Error Return.
    `void` | `setMFNRecordLevelErrorReturn(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the MFN Record Level Error Return.
    `void` | `setprimaryKeyValueMFA(ISingleCollection<IDataType> objprimaryKeyValueMFAList)` Set the Primary Key Value MFA.
    `void` | `setPrimaryKeyValueType(ISingleCollection<ID> objtempPrimaryKeyValueTypeMFAList)` Set the Primary Key Value Type MFA.
    `void` | `setRecordLevelEventCode(ID objrecordLevelEventCode)` Set the Record Level Event Code.
    `void` | `setRecordLevelEventCode(java.lang.String strRecordLevelEventCode)` Set the Record Level Event Code.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MFA

          public MFA()

      Constructs the MFA segment.

  - ### Method Detail

    - #### getEventCompletionDate_Time

          public DTM getEventCompletionDate_Time()

      Retrieves the Event Completion Date Time. This field may be require or optional depending on the site specifications for the given master file, master file event, and receiving facility.
      Returns:
        DTM - eventCompletionDate_Time

    - #### getMFNControlID

          public ST getMFNControlID()

      Retrieves the MFN Control ID. This field contains a number or other identifier that uniquely identifies this change to this record from the point of view of the originating system.
      Returns:
        ST - mFNControlID

    - #### getMFNRecordLevelErrorReturn

          public CWE getMFNRecordLevelErrorReturn()

      Retrieves the MFN Record Level Error Return. This field contains the status of the requested update. Site-defined table, specific to each master file being updated via this transaction.
      Returns:
        CWE - mFNRecordLevelErrorReturn

    - #### getPrimaryKeyValueMFA

          public ISingleCollection<IDataType> getPrimaryKeyValueMFA()

      Retrieves the Primary Key Value MFA. This field uniquely identifies the record of the master file.
      Returns:
        ISingleCollection - primaryKeyValueMFA

    - #### getPrimaryKeyValueTypeMFA

          public ISingleCollection<ID> getPrimaryKeyValueTypeMFA()

      Retrieves the Primary Key Value Type MFA. This field contains the HL7 data type of MFA-5 - Primary Key Value - MFA.
      Returns:
        ISingleCollection - primaryKeyValueTypeMFA

    - #### getRecordLevelEventCode

          public ID getRecordLevelEventCode()

      Retrieves the Record Level Event Code. This field defines record-level event for the master file record identified by the MFI segment and the primary key in this segment.
      Returns:
        ID - recordLevelEventCode

    - #### setRecordLevelEventCode

          public void setRecordLevelEventCode(java.lang.String strRecordLevelEventCode)

      Set the Record Level Event Code. This field defines record-level event for the master file record identified by the MFI segment and the primary key in this segment.
      Parameters:
        `strRecordLevelEventCode` - String value of code.

    - #### setRecordLevelEventCode

          public void setRecordLevelEventCode(ID objrecordLevelEventCode)

      Set the Record Level Event Code. This field defines record-level event for the master file record identified by the MFI segment and the primary key in this segment.
      Parameters:
        `objrecordLevelEventCode` - object of Record Level Event Code.

    - #### setMFNControlID

          public void setMFNControlID(java.lang.String strMFNControlID)

      Set the MFN Control ID. This field contains a number or other identifier that uniquely identifies this change to this record from the point of view of the originating system.
      Parameters:
        `strMFNControlID` - Used as MFNControlID.

    - #### setMFNControlID

          public void setMFNControlID(ST objmFNControlID)

      Set the MFN Control ID. This field contains a number or other identifier that uniquely identifies this change to this record from the point of view of the originating system.
      Parameters:
        `objmFNControlID` - object of MFN Control ID.

    - #### setEventCompletionDate_Time

          public void setEventCompletionDate_Time(java.lang.String strTime)

      SetEventCompletionDate_Time
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setEventCompletionDate_Time

          public void setEventCompletionDate_Time(DTM objeventCompletionDate_Time)

      SetEventCompletionDate_Time
      Parameters:
        `objeventCompletionDate_Time` - object of Event Completion Date_Time.

    - #### setMFNRecordLevelErrorReturn

          public void setMFNRecordLevelErrorReturn(java.lang.String strIdentifier,
                                          java.lang.String strText,
                                          java.lang.String strNameOfCodingSystem,
                                          java.lang.String strAlternateIdentifier,
                                          java.lang.String strAlternateText,
                                          java.lang.String strNameOfAlternateCodingSystem,
                                          java.lang.String strCodingSystemVersionID,
                                          java.lang.String strAlternateCodingSystemVersionId,
                                          java.lang.String strOriginalText,
                                          java.lang.String strSecondAlternateIdentifier,
                                          java.lang.String strSecondAlternateText,
                                          java.lang.String strNameofSecondAlternateCodingSystem,
                                          java.lang.String strSecondAlternateCodingSystemVersionID,
                                          java.lang.String strCodingSystemOID,
                                          java.lang.String strValueSetOID,
                                          java.lang.String strValueSetVersionID,
                                          java.lang.String strAlternateCodingSystemOID,
                                          java.lang.String strAlternateValueSetOID,
                                          java.lang.String strAlternateValueSetVersionID,
                                          java.lang.String strSecondAlternateCodingSystemOID,
                                          java.lang.String strSecondAlternateValueSetOID,
                                          java.lang.String strSecondAlternateValueSetVersionID)

      Set the MFN Record Level Error Return. This field contains the status of the requested update. Site-defined table, specific to each master file being updated via this transaction.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setMFNRecordLevelErrorReturn

          public void setMFNRecordLevelErrorReturn(CWE objmFNRecordLevelErrorReturn)

      Set the MFN Record Level Error Return. This field contains the status of the requested update. Site-defined table, specific to each master file being updated via this transaction.
      Parameters:
        `objmFNRecordLevelErrorReturn` - object of MFN Record Level Error Return.

    - #### addprimaryKeyValueMFA

          public void addprimaryKeyValueMFA(IDataType objprimaryKeyValueMFA)

      Add the Primary Key Value MFA. This field uniquely identifies the record of the master file.
      Parameters:
        `objprimaryKeyValueMFA` - Used as primaryKeyValueMFA.

    - #### setprimaryKeyValueMFA

          public void setprimaryKeyValueMFA(ISingleCollection<IDataType> objprimaryKeyValueMFAList)

      Set the Primary Key Value MFA. This field uniquely identifies the record of the master file.
      Parameters:
        `objprimaryKeyValueMFAList` - List of Primary Key Value MFA.

    - #### addPrimaryKeyValueType

          public void addPrimaryKeyValueType(java.lang.String strCharacterSet)

      Add the Primary Key Value Type MFA. This field contains the HL7 data type of MFA-5 - Primary Key Value - MFA.
      Parameters:
        `strCharacterSet` - Used as CharacterSet.

    - #### addPrimaryKeyValueType

          public void addPrimaryKeyValueType(ID objtempPrimaryKeyValueTypeMFA)

      Add the Primary Key Value Type MFA. This field contains the HL7 data type of MFA-5 - Primary Key Value - MFA.
      Parameters:
        `objtempPrimaryKeyValueTypeMFA` - object of Primary Key Value Type MFA.

    - #### setPrimaryKeyValueType

          public void setPrimaryKeyValueType(ISingleCollection<ID> objtempPrimaryKeyValueTypeMFAList)

      Set the Primary Key Value Type MFA. This field contains the HL7 data type of MFA-5 - Primary Key Value - MFA.
      Parameters:
        `objtempPrimaryKeyValueTypeMFAList` - List of Primary Key Value Type MFA.

    - #### parse

          public int parse(java.lang.String strSegmentStream,
                  IDelimiter objIDelimiter)
                    throws InvalidSegmentException,
                           java.io.IOException

      Parses HL7 Segment Strings from any Stream into HL7 Segment object. This method checks for the Repetition of the fields in the Segment. It also checks for the optionality of the fields as whether they are mandatory or optional. Successful parsing of the segment populates the object with the data present on the stream and provides easy accessor and mutator methods to navigate the message. It also leads to failure if version of given HL7 Message is not 2.8.2. This method raises exception if there is Segment which is not valid as per HL7 v 2.8.2 standard.
      Specified by:
        `parse` in interface `ISegment`
      Overrides:
        `parse` in class `Segment`
      Parameters:
        `strHL7segmentString` - Object of HL7Stream.
        `objIDelimiter` - Object of class Delimiter.
      Returns:
        int - Success if segment is valid. - Fail if segment in not valid.
      Throws:
        `InvalidSegmentException` - Thrown when Segment Validation Fails.
        `java.io.IOException` - Signals that an I/O exception of some sort has occurred.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation chcecks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails